//! The RV32I System instructions.
//! Used to access system functionnality that might required a certain privilege level.
//! Currently unimplemented.

use crate::core::isa::{Instruction, RVException, RVHart};

/// The System instructions shared opcode.
pub const SYSTEM_OPCODE: u32 = 0x73;

/// A decoded system instruction ready to be executed.
pub struct SystemInstruction {}

impl SystemInstruction {
    /// Decode the given raw `instruction` to issue a new `SystemInstruction` ready to be executed.
    pub fn new(_instruction: u32) -> Self {
        SystemInstruction {}
    }
}

impl Instruction for SystemInstruction {
    fn execute(&self, _core: &mut RVHart) -> Result<(), RVException> {
        Ok(())
    }
}

#[cfg(test)]
mod test {
    // TODO: Add test when a proper implementation will be done.
}
